# The very basic stuff
Because this is not the central part of the course and contains not executable
code, it will be more a collection of useful information rather than a detailed
description of the topic

Hardware and Software developed side-by-side starting the first half of the 20th
century mainly as industrial tools to push forward automation in production and
data assesment and analysis but also from the scientific area
## Hardware
Notable mentions:
- Z1: first programmable computer by Konrad Zuse around 1937, purely mechanical, privately financed
![Z1 image](https://upload.wikimedia.org/wikipedia/commons/thumb/3/34/German_Museum_of_Technology%2C_Berlin_2017_024.jpg/1920px-German_Museum_of_Technology%2C_Berlin_2017_024.jpg "Z1 in the museum today")
- ENIAC: first programmable electronic computer, 1945-1956, 18000 tubes, Army research Lab
![ENIAC image](https://upload.wikimedia.org/wikipedia/commons/4/4e/Eniac.jpg "ENIAC")

Mechanical was not reliable, so the rapid miniaturiaztion for electronic parts pushed the computer
 hardware from tubes to transistors to [microprocessors beginning in the 1960s](https://learn.saylor.org/mod/page/view.php?id=22020)

If you are more interested in the history part, check [IBM](https://en.wikipedia.org/wiki/IBM). It shows the close relation between computing, industry, military and society over more than a century.

### Basic parts of a computer system

Almost all computers follow the so-called [von Neumann architectur](https://upload.wikimedia.org/wikipedia/commons/thumb/e/e5/Von_Neumann_Architecture.svg/720px-Von_Neumann_Architecture.svg.png) from 1945:
- Input and Output 
- Central processing for arithmetics/logics and memory controlling
- Memory

What a computer can do is basically
- write to memory
- read from memory
- compute with the memory

Different chipsets offer different operations with single instructions collected under the term [Assembler or Assembly language](https://en.wikipedia.org/wiki/Assembly_language#Assembler)

### Memory in action

input program
```c
#include <stdlib.h>                                                            
#include <stdio.h>
#include <math.h>
 
int main(int argc, char **argv) {
  double x = atof(argv[1]);
  double result = x+x;
  printf("results %f\n", result);
  return 0;
}
```

compile it to assembly on two different systems (mistral + laptop)



### Memory Hierarchy
| type | access | size | cost |
|--|--|--|--|
| registers |5ns |1e2| part of CPU |
|caches (SRAM)| 10ns |1e6 | 100.00 $/MB |
|main memory (DRAM)| 100ns | 1e9 | 1.00 $/MB|
|hard disk |5000ns |1e11  | .05 $/MB|



## Software

Together with programmable hardware the languges evolved. Hence Konrad Zuse was again the first:
[_Plankalkühl_](http://zuse.zib.de/item/DB2j_t_w1fbxvaiq) non-published book from 1945 because of WWII. Another old standing member in the family of programming languages is FORTRAN from 1950s.

[Good overview of languages](https://learn.saylor.org/mod/page/view.php?id=22022)

Basic goal:
- expression of mathematical formual (computation!)
- expression of algorithms


## Further readings

[This collection of free online books](https://www.sciencebooksonline.info/computer-science.html) is a good start

